package auth

import (
	"time"

	"gorm.io/gorm"
)

type Config struct {
	Secret        string        `env:"SECRET"`
	ValidDuration time.Duration `env:"VALID_DURATION"`
	AdminName     string        `env:"ADMIN_NAME"`
	AdminPassword string        `env:"ADMIN_PASSWORD"`
}

type Service struct {
	cfg *Config
	db  *gorm.DB
}

func New(cfg *Config, db *gorm.DB) *Service {
	return &Service{
		cfg,
		db,
	}
}
